function YGS_BAG_PARSE()
	YGSBAG={}
	for b=0,4 do 
		for s=1,GetContainerNumSlots(b) do 
			if (GetContainerItemLink(b,s)) then
				--YssGuildShop_ConMsg(GetContainerItemLink(b,s)) -- debugline
				local texture, itemCount, locked, quality, readable = GetContainerItemInfo(b,s)
				local itemName = GetItemInfo(GetContainerItemLink(b,s))
				if YGSBAG[itemName] ~= nil then
					YGSBAG[itemName][2] = YGSBAG[itemName][2] + itemCount
				else
					YGSBAG[itemName] = {}
					YGSBAG[itemName][1] = YssGuildShop_CL(GetContainerItemLink(b,s))
					YGSBAG[itemName][2] = itemCount
				end
			end
		end
	end
	for inv=1,19 do
		if (GetInventoryItemLink("player",inv)) then
			--YssGuildShop_ConMsg(GetContainerItemLink(b,s)) -- debugline
			local itemCount = GetInventoryItemCount("player",inv)
			local itemName = GetItemInfo(GetInventoryItemLink("player",inv))
			if YGSBAG[itemName] ~= nil then
				YGSBAG[itemName][2] = YGSBAG[itemName][2] + itemCount
			else
				YGSBAG[itemName] = {}
				YGSBAG[itemName][1] = YssGuildShop_CL(GetInventoryItemLink("player",inv))
				YGSBAG[itemName][2] = itemCount
			end
		end
	end
	if YGSBANK ~= nil and YGSBAG ~= nil then
		--YssGuildShop:Print("Merge Scheduled") -- debugline
		YGS_BANK_BAG_MERGE()
	end
end

function YGS_BANK_PARSE()
	YGSBANK = {}
	local uniquecheck = 0
	local b = BANK_CONTAINER
        for s=1,GetContainerNumSlots(b) do 
		if (GetContainerItemLink(b,s)) then
			local texture, itemCount, locked, quality, readable = GetContainerItemInfo(b,s)
			local itemName = GetItemInfo(GetContainerItemLink(b,s))
			if YGSBANK[itemName] ~= nil then
				YGSBANK[itemName][2] = YGSBANK[itemName][2] + itemCount
			else
				YGSBANK[itemName] = {}
				YGSBANK[itemName][1] = YssGuildShop_CL(GetContainerItemLink(b,s))
				YGSBANK[itemName][2] = itemCount
			end
		end
        end
        for b=5,11 do 
		for s=1,GetContainerNumSlots(b) do 
			if (GetContainerItemLink(b,s)) then
				--YssGuildShop_ConMsg(GetContainerItemLink(b,s)) -- debugline
				local texture, itemCount, locked, quality, readable = GetContainerItemInfo(b,s)
				local itemName = GetItemInfo(GetContainerItemLink(b,s))
				if YGSBANK[itemName] ~= nil then
					YGSBANK[itemName][2] = YGSBANK[itemName][2] + itemCount
				else
					YGSBANK[itemName] = {}
					YGSBANK[itemName][1] = YssGuildShop_CL(GetContainerItemLink(b,s))
					YGSBANK[itemName][2] = itemCount
				end
			end
		end
        end
end

function YGS_BANK_BAG_MERGE()
	--YssGuildShop:Print("Merging.......") -- debugline
	local YGS_LOCAL_DB = {}
	local uniquecheck = 0
	if YGSBAG ~= nil then
		if YGSBANK ~= nil then
			for key, value in pairs(YGSBANK) do
				YGS_LOCAL_DB[key] = {}
				YGS_LOCAL_DB[key][1] = rawget(value, 1)
				YGS_LOCAL_DB[key][2] = rawget(value, 2)
			end
			for key, value in pairs(YGSBAG) do
				if YGS_LOCAL_DB[key] ~= nil then
					YGS_LOCAL_DB[key][2] = "[" .. value[2] .. "/" .. YGS_LOCAL_DB[key][2] .. "/" .. (YGS_LOCAL_DB[key][2] + value[2]) .. "]"
				else
					YGS_LOCAL_DB[key] = rawget(YGSBAG, key)
					YGS_LOCAL_DB[key][2] =  "[0/"..YGS_LOCAL_DB[key][2].."/"..YGS_LOCAL_DB[key][2].."]"
				end
			end
			for key, value in pairs(YGS_LOCAL_DB) do
				--YssGuildShop:Print(value[2])
				if string.gsub (value[2], "%[.*%]", "true") ~= "true" then
					--YssGuildShop:Print("Fixed: "..key)
					YGS_LOCAL_DB[key][2] = "[0/"..value[2].."/"..value[2].."]"
				end
			end
		end
	end
	table.sort(YGS_LOCAL_DB)
	
	uniquecheck = 0
	YGS_LOCAL_DB["YGS_ID"] = YssGuildShop:ID()
	if YGSDB ~= nil and YGSDB ~= {} then
		for k=1,table.maxn(YGSDB) do
			if YGSDB[k]["YGS_ID"][1] == YGS_LOCAL_DB["YGS_ID"][1] then
				YGSDB[k] = YGS_LOCAL_DB
				uniquecheck = 1
			end
		end
		if uniquecheck == 0 then
			YGSDB[table.maxn(YGSDB)+1] = YGS_LOCAL_DB
		end
	else
		YGSDB = {}
		YGSDB[1] = YGS_LOCAL_DB
	end

	YssGuildShop:Send()
end

function YssGuildShop_CL(link)
	if not link then return end
	local itemLink

	local _, _, itemID, ench, j1, j2, j3, j4, suffixID, uniqueID = string.find(link, "(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+)")

	j1 = tonumber(j1)
	j2 = tonumber(j2)
	j3 = tonumber(j3)
	j4 = tonumber(j4)
	suffixID = tonumber(suffixID)
	if (suffixID < 0) then
		uniqueID = bit.band( tonumber(uniqueID), 65535)
	end
  
	if(j1 == 0 and j2 == 0 and j3 == 0 and j4 == 0) then --If there are no occupied Jewel slots
		if(tonumber(ench) == 0 and suffixID == 0) then --If there is no enchant nor suffix
			itemLink = itemID --Store itemID only to save memory
		elseif(suffixID < 0) then --If the suffixID is negative, store the full uniqueID
			itemLink = itemID..":"..ench..":"..suffixID..":"..uniqueID
		else --Use the pre 2.0.1 style itemString to save memory
			itemLink = itemID..":"..ench..":"..suffixID..":0"
		end
	elseif(suffixID < 0) then --Some jewel slots are occupied and the suffixid is negative
		--Full link with uniqueID needed
		itemLink = itemID..":"..ench..":"..j1..":"..j2..":"..j3..":"..j4..":"..suffixID..":"..uniqueID	
	else
		itemLink = itemID..":"..ench..":"..j1..":"..j2..":"..j3..":"..j4..":"..suffixID --Full link needed minus uniqueID
	end

	return itemLink
end

function YssGuildShop_FL(item)
	local link
	if( not item ) then return nil end

	local ncolon = select(2,string.gsub(item, ":", ""))
	
	if( ncolon == 3 ) then
		link = string.gsub(item, "(%-?%d+):(%-?%d+):(%-?%d+):(%-?%d+)", "%1:%2:0:0:0:0:%3:%4")
	elseif( ncolon < 7 ) then	--Link is too short
		link = item .. string.rep(":0",7-ncolon)
	elseif( ncolon > 7 ) then	--Link is too long for some reason
		link = string.match(item, "^(%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+:%-?%d+)")
	else
		link = item
	end
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo("item:"..link) 
	return itemLink
end
